﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NAudio.Wave;
using System.Windows.Forms;
using System.Threading;

namespace dcf77_send {
    class dcf77_output {
        public dcf77_output() {

        }
        ~dcf77_output() {

        }
        WaveTone tone;

        public void start(DateTime startTime) {
            tone = new WaveTone(77500, 0.15);
            stream = new BlockAlignReductionStream(tone);

            tone.startTm = startTime;
            for (int i = 0; i < 2000; i++) {
                DateTime dt = startTime.Add(new TimeSpan(0, i, 0));
                tone.dcf77datalist.Add(dt, dcf77_encode.calcDcf77Bytes(dt));
            }

            timerAddData.Interval = 100;
            timerAddData.Tick += new EventHandler(timerAddDataTick);
            timerAddData.Enabled = true;

            output = new DirectSoundOut();
            output.Init(stream);
            output.Play();
        }
        public void stop() {
            timerAddData.Stop();

            if (output != null) output.Stop();


            if (output != null) {
                output.Dispose();
                output = null;
            }
            if (stream != null) {
                stream.Dispose();
                stream = null;
            }

            Thread.Sleep(10);

            tone.dcf77datalist.Clear();
        }


        System.Windows.Forms.Timer timerAddData = new System.Windows.Forms.Timer();
        private void timerAddDataTick(object sender, EventArgs e) {
            //while (tone.dcf77datalist.Count < 2000) {
                //Fehler: Beim hinzufügen von Elementen

                //DateTime dt = tone.dcf77datalist.Last().Key.Add(new TimeSpan(0, 1, 0));
                //tone.dcf77datalist.Add(dt, dcf77_encode.calcDcf77Bytes(dt));
            //}
        }





        private DirectSoundOut output = null;
        private BlockAlignReductionStream stream = null;

        private class WaveTone : WaveStream {
            public Dictionary<DateTime, byte[]> dcf77datalist = new Dictionary<DateTime, byte[]>();
            public DateTime startTm;
            public DateTime actualTm;

            private double frequency;
            private double amplitude;
            private double time;

            public WaveTone(double f, double a) {
                this.time = 0;
                this.frequency = f;
                this.amplitude = a;
            }

            public override long Position {
                get;
                set;
            }

            public override long Length {
                get { return long.MaxValue; }
            }

            public override WaveFormat WaveFormat {
                get { return new WaveFormat(192000, 16, 1); }
            }

            public override int Read(byte[] buffer, int offset, int count) {
                int samples = count / 2;
                for (int i = 0; i < samples; i++) {
                    double timerel = time - (double)((int)time);
                    actualTm = startTm;
                    actualTm = actualTm.Add(new TimeSpan(0, (int)time / 60, 0));

                    DateTime getMinuteSecondTemp = startTm;
                    getMinuteSecondTemp = getMinuteSecondTemp.Add(new TimeSpan(0, 0, (int)time));
                    int actualSecond = getMinuteSecondTemp.Second;


                    double sine = 0.0;
                    while (true) {
                        if (dcf77datalist.ElementAt(0).Key == actualTm) {
                            byte[] data = dcf77datalist.ElementAt(0).Value;

                            if(data[actualSecond]==0) {
                                if(timerel<0.1) {
                                    sine = amplitude * Math.Sin(Math.PI * 2 * frequency * time);
                                } else {
                                    sine = Math.Sin(Math.PI * 2 * frequency * time);
                                }
                            } else if(data[actualSecond]==1) {
                                if(timerel<0.2) {
                                    sine = amplitude * Math.Sin(Math.PI * 2 * frequency * time);
                                } else {
                                    sine = Math.Sin(Math.PI * 2 * frequency * time);
                                }
                            } else {
                                sine = Math.Sin(Math.PI * 2 * frequency * time);
                            }

                            break;
                        } else {
                            if (dcf77datalist.Count > 0) {
                                dcf77datalist.Remove(dcf77datalist.ElementAt(0).Key);
                            } else throw new Exception("Keine Encodete Daten mehr vorhanden!");
                        }
                    }




                    time += 1.0 / WaveFormat.SampleRate;

                    short truncated = (short)Math.Round(sine * (Math.Pow(2, 15) - 1));
                    buffer[i * 2] = (byte)(truncated & 0x00ff);
                    buffer[i * 2 + 1] = (byte)((truncated & 0xff00) >> 8);
                }

                return count;
            }
        }
    }
}
